//System.mm
//Created by and Tobais Stamm
//The Macintosh-File of the platform-dependent implementation

///////////////////////
//ATTENTION!
///////////////////////
//This file should not be used for the WINDOWS-Compilation
//It will produce a lot! of errors.
//Even as there is a define-clause, it may fail to build the application


#import "System.h"
#if(PROGRAM_COMPILES_ON==MAC_OS_X)

#include "Project.h"

@implementation System

///////////////////
//Initialisation-Function
- (IBAction)setup:(id)sender{

		//Creation of the superroot
		superroot=new SoSeparator();
		superroot->ref();
	
		//send the superroot to the project
		project = new Project(superroot);

		//display the graph
		[scenegraph setRoot:superroot];
		[scenegraph viewAll];
		[[scenegraph camera] reorient:SbRotation(SbVec3f(1,0,0),-.2)];
	}

/////////////////
//Quit
  - (IBAction)quit:(id)sender
  {
		delete project;
		superroot->unref();
		[[NSApplication sharedApplication]terminate:self];
  }


//////////////////////
//The keyboard-event-function passing the character to the universal keyboard-handler
- (IBAction)key:(id)sender{
	char c;
	[[sender keyEquivalent] getCString:&c];
	project->Key(c);
}

@end

int main(int argc, char *argv[]){
	return NSApplicationMain(argc,  (const char **) argv);
}

#endif //PROGRAM_COMPILES_ON==MAC_OS_X
