//ListArray.h
//Created by Lukas Fuellemann and Tobais Stamm
//The include-file of the ListArray

#include "Globals.h"
class ListElement;
class Sphere;

//Cell-Size of uniform-sparse array
#define NOF_CELLS (int)((DRUM_RADIUS*2)/(MAX_RADIUS*2.5))

class ListArray{

//The array of all cells
ListElement* cells[NOF_CELLS][NOF_CELLS][NOF_CELLS];

public:

//Constructor
ListArray();
//Destructor
~ListArray();

//Add a sphere to the list
void Add(Sphere* sphere);
//Traverse all lists of the sphere
void Traverse(Sphere* sphere, void(*callback)(Sphere* sphere1, Sphere* sphere2));
//Get the upper/lower Index in the List array
void getLowerIndexes(int* u, Sphere* sphere);
void getUpperIndexes(int* u, Sphere* sphere);
//delete all Lists
void CleanAll();

};

