//ListElement.cpp
//Created by Lukas Fuellemann and Tobais Stamm
//The file of the Listelements

#include "Globals.h"
#include "ListElement.h"

//Constructor
ListElement::ListElement(Sphere * sphere){
	this->sphere = sphere;
	next=NULL;
}

//Destructor
ListElement::~ListElement(){
	if(next){delete next;}
}

//Set the next Element
void ListElement::setNext(ListElement* next){
	this->next=next;
}

//Get the next Element
ListElement* ListElement::getNext(){
	return next;
}

//Get the sphere
Sphere* ListElement::getSphere(){
	return sphere;
}
