//System.h
//Created by Lukas Fuellemann and Tobais Stamm
//The include-File of the platform-dependent implementation

//Definition of the System the Project compiles on
#define MAC_OS_X   0
#define WINDOWS    1
#define PROGRAM_COMPILES_ON     MAC_OS_X


#if(PROGRAM_COMPILES_ON==WINDOWS)

//
//
// Windows-Code
//
//


#endif //PROGRAM_COMPILES_ON==WINDOWS
/////////////////////////////////////////////////
#if(PROGRAM_COMPILES_ON==MAC_OS_X)

#import <Cocoa/Cocoa.h>
#import <Sc21/Sc21.h>
#include "Globals.h"

class Project;

//Define the outlets
@interface System : NSObject {
  IBOutlet SCSceneGraph * scenegraph;
  IBOutlet SCExaminerHandler * examiner;
  IBOutlet SCController * controller;
  IBOutlet SCView * view;
	Project * project;
	SoSeparator * superroot;
}

//Define the action-functions
- (IBAction)key:(id)sender;
- (IBAction)quit:(id)sender;
- (IBAction)setup:(id)sender;
//- (void)init;

@end

#endif //PROGRAM_COMPILES_ON==MAC_OS_X
